<template>
  <!-- <div class="header_nox">
      <el-button type="warning" circle @click="exportWord">下载</el-button>
      <el-button type="primary" circle v-show="!editable" @click="editable = !editable">编辑</el-button>
      <el-button type="primary" v-show=editable @click="saveData">确定</el-button>
    </div> -->
  <div id="printContent" ref="imageWrapper">
    <h3>冲床周润滑记录</h3>
    <div class="title_form">
      <div class="title_form_input">
        <span>生产线：</span>
        <span>{{ headData.head.shengcx }}</span>
      </div>
      <div class="title_form_input">
        <span>产品：</span>
        <span>{{ headData.head.chanpin }}</span>
      </div>
      <div class="title_form_input">
        <span>日期：</span>
        <span>{{ headData.head.reportTime }}</span>
      </div>
      <div class="title_form_input">
        <span>班次：</span>
        <span>{{ headData.head.banci }}</span>
      </div>
      <div class="title_form_input">
        <span>记录员：</span>
        <span>{{ headData.head.jiluyuan }}</span>
      </div>
      <div class="title_form_input">
        <span>接班时间：</span>
        <span>{{ headData.head.jieban1 }}</span>
      </div>
      <div class="title_form_input">
        <span>交班时间：</span>
        <span>{{ headData.head.jiaoban1 }}</span>
      </div>
    </div>
    <el-divider />

    <HJTABLE
      :SClist="c3_weekHeaderData"
      :tableHeader="c3_weekHeader"
      :editable="editable"
    >
    </HJTABLE>
  </div>
</template>

<script>
const item = {
  name: "",
  birth: "",
  province: "",
  city: "",
  address: "",
  phone: "",
};
const header = {
  prop: "key",
  label: "自定义",
  editable: false,
  type: "input",
};
import { ref, reactive, onMounted } from "vue";
import { ElMessage } from "element-plus";
import { chong03VoLast, chong03VoSave } from "@/api/gaixian";
import html2canvas from "html2canvas";
import docxtemplater from "docxtemplater";
import PizZip from "pizzip";
import JSZipUtils from "jszip-utils";
import { saveAs } from "file-saver";
import HJTABLE from "@/components/arj/arj-table";
export default {
  name: "",
  components: { HJTABLE },
  props: {},
  setup(props) {
    const c3_weekHeader = reactive([
      { prop: "no", label: "序号", editable: "false", type: "text" },
      { prop: "zq", label: "周期", editable: "false", type: "text" },
      { prop: "rhbw", label: "润滑部位", editable: "false", type: "text" },
      { prop: "ffgj", label: "方法工具", editable: "false", type: "text" },
      { prop: "gj", label: "工具", editable: "false", type: "text" },
      { prop: "zyl", label: "注油量", editable: "false", type: "text" },
      { prop: "pdbz", label: "判断标准", editable: "false", type: "text" },
      { prop: "banci", label: "班次", editable: "false", type: "text" },
      { prop: "week1", label: "第一周", editable: "false", type: "text" },
      { prop: "week2", label: "第二周", editable: "false", type: "text" },
      { prop: "week3", label: "第三周", editable: "false", type: "text" },
      { prop: "week4", label: "第四周", editable: "false", type: "text" },
      { prop: "oper1", label: "操作员1", editable: "false", type: "text" },
      { prop: "oper2", label: "操作员2", editable: "false", type: "text" },
      { prop: "lingb1", label: "领班1", editable: "false", type: "text" },
      { prop: "lingb2", label: "领班2", editable: "false", type: "text" },
    ]);

    let tableData = reactive([]);
    const formInline = reactive({
      user: "",
      region: "",
    });
    const imageWrapper = ref(null);

    let headData = reactive({
      head: {},
    });

    let labelName = {
      b1: "铁使用情况",

      b2: "生产速度与压力",
      b3: "基本尺寸",
      b4: "外观检测项目",
    };
    let editable = ref(false);

    let SClist = ref([]);
    let hjData = ref({});

    let c3_weekHeaderData = ref([]);

    const submitForm = () => {};

    const handleEdit = (row) => {
      row.editable = true;
    };
    const handleDelete = (index) => {
      this.tableData.splice(index, 1);
    };
    const prepend = (index) => {
      item.editable = true;
      this.tableData.splice(index, 0, item);
    };
    const append = (index) => {
      item.editable = true;
      this.tableData.splice(index + 1, 0, item);
    };
    const deleteCurrentColumn = (index) => {
      this.tableHeader.splice(index, 1);
    };
    const insertBefore = (index) => {
      header.editable = true;
      this.tableHeader.splice(index, 0, header);
    };

    const getListData = async () => {
      const data = await chong03VoLast();
      console.log(".........", data);
      headData.head = data.data.head;
      if (headData.head.reportTime != null)
        headData.head.reportTime = headData.head.reportTime.substr(0, 10);
      // headData.head.reportTime = headData.head.reportTime.substr(0, 10);
      // headData.head.jieban1 = headData.head.jieban.substr(11, 5);
      // headData.head.jiaoban1 = headData.head.jiaoban.substr(11, 5);
      c3_weekHeaderData.value = data.data.c3WeekList;

      hjData.value = {
        ...headData.head,
        t1: c3_weekHeaderData.value,
      };
    };

    const saveData = async () => {
      editable = false;
      let data = {
        head: headData.head,
        c3WeekList: c3_weekHeaderData.value,
      };
      console.log("save data...", data);
      const dt = await chong03VoSave(data);
      if (dt.code == 0) {
        ElMessage({
          message: "修改成功",
          type: "success",
        });
      }
      console.log(dt);
    };
    //截图
    const toImage = () => {
      html2canvas(imageWrapper.value, {
        logging: false,
        allowTaint: true,
        scale: window.devicePixelRatio,
        // width: shareContent.clientWidth, //dom 原始宽度
        // height: shareContent.clientHeight,
        scrollY: 0,
        scrollX: 0,
        useCORS: true,
        backgroundColor: "#ffffff",
      }).then(function (canvas) {
        // console.log(canvas);
        let imgUrl = canvas.toDataURL("image/png");
        var tempLink = document.createElement("a"); // 创建一个a标签
        tempLink.style.display = "none";
        tempLink.href = imgUrl;
        tempLink.setAttribute("download", "冲床周润滑记录"); // 给a标签添加下载属性
        if (typeof tempLink.download === "undefined") {
          tempLink.setAttribute("target", "_blank");
        }
        document.body.appendChild(tempLink); // 将a标签添加到body当中
        tempLink.click(); // 启动下载
        document.body.removeChild(tempLink); // 下载完毕删除a标签
        window.URL.revokeObjectURL(imgUrl);
      });
    };
    // 点击导出word
    function exportWord() {
      // 读取并获得模板文件的二进制内容
      JSZipUtils.getBinaryContent("g03.docx", function (error, content) {
        // input.docx是模板。我们在导出的时候，会根据此模板来导出对应的数据
        // 抛出异常
        if (error) {
          throw error;
        }

        // 创建一个JSZip实例，内容为模板的内容
        let zip = new PizZip(content);
        // 创建并加载docxtemplater实例对象

        let doc = new docxtemplater().loadZip(zip).setOptions({
          nullGetter: function () {
            return "";
          },
        });
        // 设置模板变量的值
        doc.setData({
          ...hjData.value,
        });

        try {
          // 用模板变量的值替换所有模板变量
          doc.render();
        } catch (error) {
          // 抛出异常
          let e = {
            message: error.message,
            name: error.name,
            stack: error.stack,
            properties: error.properties,
          };
          console.log(JSON.stringify({ error: e }));
          throw error;
        }

        // 生成一个代表docxtemplater对象的zip文件（不是一个真实的文件，而是在内存中的表示）
        let out = doc.getZip().generate({
          type: "blob",
          mimeType:
            "application/vnd.openxmlformats-officedocument.wordprocessingml.document",
        });
        // 将目标文件对象保存为目标类型的文件，并命名
        saveAs(out, "冲床周润滑记录.docx");
      });
    }
    getListData();
    onMounted(() => {});
    return {
      saveData,
      submitForm,
      formInline,
      tableData,
      insertBefore,
      deleteCurrentColumn,
      append,
      prepend,
      handleDelete,
      handleEdit,
      editable,
      getListData,
      headData,
      toImage,
      imageWrapper,
      labelName,
      exportWord,
      c3_weekHeader,
      c3_weekHeaderData,
      chong03VoLast,
      chong03VoSave,
    };
  },
};
</script>
<style lang="scss" scoped>
.header_nox {
  text-align: right;
}

#printContent h3 {
  text-align: center;
  margin-bottom: 40px;
  font-size: 26px;
  font-weight: bold;
}

.title_form {
  display: flex;
  justify-content: space-around;
  align-items: center;
  // margin-bottom: 20px;
}

.title_form_input {
  font-size: 16px;
}
</style>
